#ifndef CLASSIFIER__H
#define CLASSIFIER__H

#include <string>
#include "TransitionSet.hpp"
#include "TestNetwork.hpp"

class Classifier
{
  private :

  std::string name;
  std::unique_ptr<TransitionSet> transitionSet;
  TestNetwork nn{nullptr};

  public :

  Classifier(const std::string & name, const std::string & topology, const std::string & tsFile);
  TransitionSet & getTransitionSet();
  TestNetwork & getNN();
  const std::string & getName() const;
};

#endif
