#ifndef TESTNETWORK__H
#define TESTNETWORK__H

#include <torch/torch.h>
#include "Config.hpp"

class TestNetworkImpl : public torch::nn::Module
{
  private :

  torch::nn::Embedding wordEmbeddings{nullptr};
  torch::nn::Linear linear{nullptr};
  int focusedIndex;

  std::vector<torch::Tensor> _denseParameters;
  std::vector<torch::Tensor> _sparseParameters;

  public :

  TestNetworkImpl(int nbOutputs, int focusedIndex);
  torch::Tensor forward(torch::Tensor input);
  std::vector<torch::Tensor> & denseParameters();
  std::vector<torch::Tensor> & sparseParameters();
};
TORCH_MODULE(TestNetwork);

#endif
